=== debian/control ===
Source: nlohmann-json3
Priority: optional
Maintainer: Hubert Chathi <uhoreg@debian.org>
Build-Depends:
 debhelper (>=9),
 doxygen,
 ghostscript,
 graphviz,
 texlive-binaries,
 texlive-latex-base,
Standards-Version: 3.9.8
Section: libs
Homepage: https://nlohmann.github.io/json/

Package: nlohmann-json3-dev
Section: libdevel
Architecture: all
Depends:
 ${misc:Depends},
Conflicts:
 nlohmann-json-dev
Description: JSON for Modern C++
 JSON library with intuitive syntax, trivial integration and serious
 testing. Other aspects, as memory efficiency and speed were not so
 important. The library consists of a single source file json.hpp.
