=== debian/changelog ===
nlohmann-json3 (3.5.0-0.1) unstable; urgency=medium

  [ Chris Lamb ]
  * Make build reproducible (Closes: #900551)
  * Do not ignore nocheck in testsuite (Closes: #900549)

  [ Gianfranco Costamagna ]
  * Non-maintainer upload
  * Update to new release (Closes: #917581)
  * Strip trailing spaces in changelog, control and rules files
  * Set compat level to 12
  * Honour no-check
  * Bump std-version to 4.3.0, no changes required
  * Fixup copyright file

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 08 Jan 2019 22:44:26 +0100
